Option Explicit

Dim dummy As Integer

Function SIGetBIOSDate (cBIOSDate As String) As Integer

ReDim cBIOSDateArray(0) As String * 1024
Dim nBIOSDateStatus As Integer

nBIOSDateStatus = GetBIOSDate(cBIOSDateArray(0))

Select Case nBIOSDateStatus

    Case SISDK_FAIL

	SIGetBIOSDate = SISDK_FAIL
	cBIOSDate = ""

    Case SISDK_SUCCESS
	SIGetBIOSDate = SISDK_SUCCESS
	cBIOSDate = Mid$(cBIOSDateArray(0), 1, InStr(cBIOSDateArray(0), Chr$(0)) - 1)

End Select

End Function

Function SIGetBIOSHighArea () As String

ReDim cGetBIOSHighArea(0) As String * 8192
Dim cBIOSHighArea As String

dummy% = GetBIOSHighArea(cGetBIOSHighArea(0))

cBIOSHighArea = Mid$(cGetBIOSHighArea(0), 1, InStr(cGetBIOSHighArea(0), Chr$(0)) - 1)

SIGetBIOSHighArea = cBIOSHighArea

End Function

Function SIGetBIOSLowArea () As String

ReDim cGetBIOSLowArea(0) As String * 8192
Dim cBIOSLowArea As String

dummy% = GetBIOSLowArea(cGetBIOSLowArea(0))

cBIOSLowArea = Mid$(cGetBIOSLowArea(0), 1, InStr(cGetBIOSLowArea(0), Chr$(0)) - 1)

SIGetBIOSLowArea = cBIOSLowArea

End Function

Function SIGetBIOSManufacturer (nBIOSManufacturer As Integer) As Integer

SIGetBIOSManufacturer = GetBIOSManufacturer(nBIOSManufacturer)

End Function

Function SIGetBusType () As Integer

SIGetBusType = GetBusType()

End Function

Function SIGetCoProcessorType () As Integer

SIGetCoProcessorType = GetCoProcessorType()

End Function

Function SIGetCPUMHz () As Integer

SIGetCPUMHz = GetCPUMHz()

End Function

Function SIGetCPUType () As Integer

SIGetCPUType = GetCPUType()

End Function

Function SIGetDiskDriveType (nDriveNumber As Integer, nDiskDriveType As Integer) As Integer

SIGetDiskDriveType = GetDiskDriveType(nDriveNumber, nDiskDriveType)

End Function

Function SIGetDOSMouseDriverType (nDOSMouseDriverType As Integer) As Integer

SIGetDOSMouseDriverType = GetDOSMouseDriverType(nDOSMouseDriverType)

End Function

Function SIGetDOSMouseDriverVersion (sDOSMouseDriverVersion As Single) As Integer

Dim nDOSMouseDriverMinorVersion As Integer
Dim nDOSMouseDriverMajorVersion As Integer
Dim nReturnCode As Integer

nReturnCode = GetDOSMouseDriverMinorVersion(nDOSMouseDriverMinorVersion)
nReturnCode = GetDOSMouseDriverMajorVersion(nDOSMouseDriverMajorVersion)

Select Case nReturnCode
    
    Case MD_NODOSMOUSEDRIVER
	SIGetDOSMouseDriverVersion = MD_NODOSMOUSEDRIVER

    Case SISDK_SUCCESS
	SIGetDOSMouseDriverVersion = SISDK_SUCCESS
	
	If nDOSMouseDriverMinorVersion = 0 Then
		sDOSMouseDriverVersion = CSng(nDOSMouseDriverMajorVersion)
	    Else
		sDOSMouseDriverVersion = CSng(nDOSMouseDriverMajorVersion) + CSng(nDOSMouseDriverMinorVersion / 100)
	End If

End Select

End Function

Function SIGetDOSVersion () As Single

Dim nDOSMinorVersion As Integer

nDOSMinorVersion = GetDOSMinorVersion()

If nDOSMinorVersion = 0 Then
    'avoid a divide by zero error
	SIGetDOSVersion = CSng(GetDOSMajorVersion())
    Else
	SIGetDOSVersion = CSng(GetDOSMajorVersion()) + CSng(nDOSMinorVersion / 10)
End If

End Function

Function SIGetFloppyDriveType (nFloppyDriveNumber As Integer, nFloppyDriveType As Integer) As Integer

SIGetFloppyDriveType = GetFloppyDriveType(nFloppyDriveNumber, nFloppyDriveType)

End Function

Function SIGetFreeDiskSpaceKB (nDriveNumber As Integer, lFreeDiskSpace As Long) As Long

SIGetFreeDiskSpaceKB = GetFreeDiskSpaceKB(nDriveNumber, lFreeDiskSpace)

End Function

Function SIGetHDBytesPerSector (nDriveNumber As Integer, nHDBytesPerSector As Integer) As Integer

SIGetHDBytesPerSector = GetHDBytesPerSector(nDriveNumber, nHDBytesPerSector)

End Function

Function SIGetHDHeads (nDriveNumber As Integer, nHDHeads As Integer) As Integer

SIGetHDHeads = GetHDHeads(nDriveNumber, nHDHeads)

End Function

Function SIGetHDSectorsPerTrack (nDriveNumber As Integer, nHDSectorsPerTrack As Integer) As Integer

SIGetHDSectorsPerTrack = GetHDSectorsPerTrack(nDriveNumber, nHDSectorsPerTrack)

End Function

Function SIGetHDTracks (nDriveNumber As Integer, nHDTracks As Integer) As Integer

SIGetHDTracks = GetHDTracks(nDriveNumber, nHDTracks)

End Function

Function SIGetLASTDRIVE () As Integer

SIGetLASTDRIVE = GetLASTDRIVE()

End Function

Function SIGetMemorySizeKB () As Integer

SIGetMemorySizeKB = GetMemorySizeKB()

End Function

Function SIGetModelType () As Integer

SIGetModelType = GetModelType()

End Function

Function SIGetMouseInterface (nMouseInterface As Integer) As Integer

SIGetMouseInterface = GetMouseInterface(nMouseInterface)

End Function

Function SIGetMouseIRQ (nMouseIRQ As Integer) As Integer

SIGetMouseIRQ = GetMouseIRQ(nMouseIRQ)

End Function

Function SIGetNetBIOSComputerName (cNetBIOSComputerName As String) As Integer

ReDim cNetBIOSComputerNameArray(0) As String * 16
Dim nReturnCode As Integer

nReturnCode = GetNetBIOSComputerName(cNetBIOSComputerNameArray(0))

Select Case nReturnCode

    Case NET_NONETWORK

	cNetBIOSComputerName = ""

    Case SISDK_SUCCESS

	cNetBIOSComputerName = Mid$(cNetBIOSComputerNameArray(0), 1, InStr(cNetBIOSComputerNameArray(0), Chr$(0)) - 1)

	cNetBIOSComputerName = Trim$(cNetBIOSComputerName)

End Select

SIGetNetBIOSComputerName = nReturnCode

End Function

Function SIGetNetworkType (nNetworkType As Integer) As Integer

SIGetNetworkType = GetNetworkType(nNetworkType)

End Function

Function SIGetNumFloppyDrives () As Integer

SIGetNumFloppyDrives = GetNumFloppyDrives()

End Function

Function SIGetNumVideoCardColors () As Long

SIGetNumVideoCardColors = GetNumVideoCardColors()

End Function

Function SIGetSysInfoDLLVersion () As String

SIGetSysInfoDLLVersion = Trim$(Str$(GetSysInfoDLLMajorVersion())) + "." + Trim$((Format$(GetSysInfoDLLMinorVersion(), "00")))

End Function

Function SIGetTotalDiskSpaceKB (nDriveNumber As Integer, lTotalDiskSpace As Long) As Long

SIGetTotalDiskSpaceKB = GetTotalDiskSpaceKB(nDriveNumber, lTotalDiskSpace)

End Function

Function SIGetVideoCardDriverType () As String

ReDim cVideoCardTypeArray(0) As String * 1024
Dim cVideoCardType As String

dummy% = GetVideoCardDriverType(cVideoCardTypeArray(0))

cVideoCardType = Mid$(cVideoCardTypeArray(0), 1, InStr(cVideoCardTypeArray(0), Chr$(0)) - 1)

SIGetVideoCardDriverType = cVideoCardType

End Function

Function SIGetVideoCardDriverVersion () As Single

Dim nVideoCardDriverMinorVersion As Integer

nVideoCardDriverMinorVersion = GetVideoCardDriverMinorVersion()

If nVideoCardDriverMinorVersion = 0 Then
    'avoid a divide by zero error if Windows 3.0 driver
	SIGetVideoCardDriverVersion = CSng(GetVideoCardDriverMajorVersion())
    Else
	SIGetVideoCardDriverVersion = CSng(GetVideoCardDriverMajorVersion()) + CSng(nVideoCardDriverMinorVersion / 100)
End If

End Function

Function SIGetVideoCardPixelResolution () As String

Dim cVideoCardPixelResolution As String

cVideoCardPixelResolution = Trim$(Str$(GetVideoCardPixelWidth())) + " x " + Trim$(Str$(GetVideoCardPixelHeight()))

SIGetVideoCardPixelResolution = cVideoCardPixelResolution

End Function

Function SIGetWindowsFreeMemoryKB () As Long

SIGetWindowsFreeMemoryKB = GetWindowsFreeMemoryKB()

End Function

Function SIGetWindowsMode () As Integer

SIGetWindowsMode = GetWindowsMode()

End Function

Function SIGetWindowsMouseDriverType () As Integer

SIGetWindowsMouseDriverType = GetWindowsMouseDriverType()

End Function

Function SIGetWindowsVersion () As Single

Dim nWindowsMinorVersion As Integer

nWindowsMinorVersion = GetWindowsMinorVersion()

If nWindowsMinorVersion = 0 Then
    'avoid a divide by zero error if Windows 3.0
	SIGetWindowsVersion = CSng(GetWindowsMajorVersion())
    Else
	SIGetWindowsVersion = CSng(GetWindowsMajorVersion()) + CSng(nWindowsMinorVersion / 100)
End If

End Function

